<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAnnuityQuoteResult ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAnnuityQuoteResult
 * @subpackage Arrays
 */
class ArrayOfAnnuityQuoteResult extends AbstractStructArrayBase
{
    /**
     * The AnnuityQuoteResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AnnuityQuoteResult[]
     */
    public $AnnuityQuoteResult;
    /**
     * Constructor method for ArrayOfAnnuityQuoteResult
     * @uses ArrayOfAnnuityQuoteResult::setAnnuityQuoteResult()
     * @param \StructType\AnnuityQuoteResult[] $annuityQuoteResult
     */
    public function __construct(array $annuityQuoteResult = array())
    {
        $this
            ->setAnnuityQuoteResult($annuityQuoteResult);
    }
    /**
     * Get AnnuityQuoteResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AnnuityQuoteResult[]|null
     */
    public function getAnnuityQuoteResult()
    {
        return isset($this->AnnuityQuoteResult) ? $this->AnnuityQuoteResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAnnuityQuoteResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnnuityQuoteResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnnuityQuoteResultForArrayConstraintsFromSetAnnuityQuoteResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAnnuityQuoteResultAnnuityQuoteResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfAnnuityQuoteResultAnnuityQuoteResultItem instanceof \StructType\AnnuityQuoteResult) {
                $invalidValues[] = is_object($arrayOfAnnuityQuoteResultAnnuityQuoteResultItem) ? get_class($arrayOfAnnuityQuoteResultAnnuityQuoteResultItem) : sprintf('%s(%s)', gettype($arrayOfAnnuityQuoteResultAnnuityQuoteResultItem), var_export($arrayOfAnnuityQuoteResultAnnuityQuoteResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AnnuityQuoteResult property can only contain items of type \StructType\AnnuityQuoteResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AnnuityQuoteResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AnnuityQuoteResult[] $annuityQuoteResult
     * @return \ArrayType\ArrayOfAnnuityQuoteResult
     */
    public function setAnnuityQuoteResult(array $annuityQuoteResult = array())
    {
        // validation for constraint: array
        if ('' !== ($annuityQuoteResultArrayErrorMessage = self::validateAnnuityQuoteResultForArrayConstraintsFromSetAnnuityQuoteResult($annuityQuoteResult))) {
            throw new \InvalidArgumentException($annuityQuoteResultArrayErrorMessage, __LINE__);
        }
        if (is_null($annuityQuoteResult) || (is_array($annuityQuoteResult) && empty($annuityQuoteResult))) {
            unset($this->AnnuityQuoteResult);
        } else {
            $this->AnnuityQuoteResult = $annuityQuoteResult;
        }
        return $this;
    }
    /**
     * Add item to AnnuityQuoteResult value
     * @throws \InvalidArgumentException
     * @param \StructType\AnnuityQuoteResult $item
     * @return \ArrayType\ArrayOfAnnuityQuoteResult
     */
    public function addToAnnuityQuoteResult(\StructType\AnnuityQuoteResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AnnuityQuoteResult) {
            throw new \InvalidArgumentException(sprintf('The AnnuityQuoteResult property can only contain items of type \StructType\AnnuityQuoteResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AnnuityQuoteResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AnnuityQuoteResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AnnuityQuoteResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AnnuityQuoteResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AnnuityQuoteResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AnnuityQuoteResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AnnuityQuoteResult
     */
    public function getAttributeName()
    {
        return 'AnnuityQuoteResult';
    }
}
